class AMIBaseException(Exception): ...

class _OperationErrors:
    class OperationError(AMIBaseException): ...
    class OperationTimeout(OperationError, TimeoutError): ...
    class UnknownOperation(OperationError, ValueError): ...
    class InvalidOperation(OperationError, ValueError): ...

    class ActionError(OperationError, AMIBaseException): ...
    class ActionTimeout(ActionError, TimeoutError): ...
    class UnknownAction(ActionError, ValueError): ...
    class InvalidAction(ActionError, ValueError): ...

    class EventError(OperationError, AMIBaseException): ...
    class EventTimeout(EventError, TimeoutError): ...
    class UnknownEvent(EventError, ValueError): ...
    class InvalidEvent(EventError, ValueError): ...

    class ResponseError(OperationError, AMIBaseException): ...
    class ResponseTimeout(ResponseError, TimeoutError): ...
    class UnknownResponse(ResponseError, ValueError): ...
    class InvalidResponse(ResponseError, ValueError): ...


class AMIExceptions(AMIBaseException):
    class ServerError(_OperationErrors): ...
    class ClientError(_OperationErrors): ...


__all__ = [
    'AMIExceptions',
]